﻿using System;
using Grendel.Base; //BaseInteractiveShape
using System.Collections.Generic;
using Grendel.Extra; //z Diagram dědičnosti pro třídu Grendel::Extra::Text


namespace Gohra
{
    enum Barva
    {
        cerna,
        bila
    }


    class Kamen
    {
        int xx;
        int yy;
        int spoctisvobodkamene;
        Barva barva;

        public Kamen(Barva barva, int spoctisvobodkamene, int xx, int yy)
        {
            this.xx = xx;
            this.yy = yy;
            this.spoctisvobodkamene = spoctisvobodkamene;
            this.barva = barva;

        }

        public void Snizpocetsvobod()
        {
            spoctisvobodkamene--;

        }

        public Barva Jakabarva
        {
            get { return barva; }
        }

        public int XX
        {
            get { return xx; }
        }

        public int YY
        {
            get { return yy; }
        }

        public int Pocetsvobod
        {
            get { return spoctisvobodkamene; }

        }
        public void Zvysitpocetsvobod()
        {
            spoctisvobodkamene++;
        }

    }

    class KamenNaCanvas
    {
        int rozmer;
        Kamen[,] polekamenu;


        public KamenNaCanvas(int rozmer)
        {
            this.rozmer = rozmer;
            this.polekamenu = new Kamen[rozmer, rozmer];
            VytvoritPoleKamenu();
        }


        public void VytvoritPoleKamenu()
        {
            for (int i = 0; i < rozmer; i++)
            {
                for (int j = 0; j < rozmer; j++)
                {
                    polekamenu[i, j] = null;
                }
            }
        }

        public bool PolozKamen(Barva barva, int xx, int yy)
        {
            if (!Zkontrolujtah(xx, yy, barva))
            {
                //polekamenu[xx, yy] = new Kamen(Barva.cerna, Spoctisvobodkamene(xx, yy), xx, yy);
                return false;
            }

            polekamenu[xx, yy] = new Kamen(barva, Spoctisvobodkamene(xx, yy), xx, yy);
            Kamen[] sousede = Sousedekamene(xx, yy);
            for (int i = 0; i < sousede.Length; i++)
            {
                sousede[i].Snizpocetsvobod();
                if ((sousede[i].Pocetsvobod == 0) && (Spoctisvobodvretezu(sousede[i].XX, sousede[i].YY) == 0))//jestlize nema libovolny soused svobody a celej retezec je na nule, tak ho odstranim 
                {

                    Odstranretezec(sousede[i].XX, sousede[i].YY);


                }

            }
            return true;
        }

        public int Spoctisvobodkamene(int xx, int yy)
        {
            if ((xx == 0 && yy == 0) || (xx == 0 && yy == rozmer - 1) ||
               (xx == rozmer - 1 && yy == 0) || (xx == rozmer - 1 && yy == rozmer - 1))
            {
                return 2 - Sousedekamene(xx, yy).Length;
            }
            if ((xx == 0) || (xx == rozmer - 1) ||
                (yy == 0) || (yy == rozmer - 1))
            {
                return 3 - Sousedekamene(xx, yy).Length;
            }
            return 4 - Sousedekamene(xx, yy).Length;
        }

        public Kamen[] Sousedekamene(int xx, int yy)
        {
            List<Kamen> sousede = new List<Kamen>();
            if ((xx != 0) && (polekamenu[xx - 1, yy] != null))
            {
                sousede.Add(polekamenu[xx - 1, yy]);
            }
            if ((xx != rozmer - 1) && (polekamenu[xx + 1, yy] != null))
            {
                sousede.Add(polekamenu[xx + 1, yy]);
            }
            if ((yy != 0) && (polekamenu[xx, yy - 1] != null))
            {
                sousede.Add(polekamenu[xx, yy - 1]);
            }
            if ((yy != rozmer - 1) && (polekamenu[xx, yy + 1] != null))
            {
                sousede.Add(polekamenu[xx, yy + 1]);
            }
            return sousede.ToArray();

        }

        public void Retezec(int xx, int yy, List<Kamen> retez)
        {
            Retezec(xx, yy, retez, polekamenu[xx, yy].Jakabarva);

        }

        public void Retezec(int xx, int yy, List<Kamen> retez, Barva b)
        {
            if (retez.Contains(polekamenu[xx, yy])) { return; }
            retez.Add(polekamenu[xx, yy]);
            Kamen[] sousederetezce = Sousedekamene(xx, yy);
            for (int i = 0; i < sousederetezce.Length; i++)
            {
                if (sousederetezce[i].Jakabarva == b)
                {
                    Retezec(sousederetezce[i].XX, sousederetezce[i].YY, retez, b);
                }
            }
        }

        public int Spoctisvobodvretezu(int xx, int yy)
        {
            int soucet = 0;
            List<Kamen> p = new List<Kamen>();
            Retezec(xx, yy, p);
            foreach (Kamen svobodyvretezu in p)
            {
                soucet = soucet + svobodyvretezu.Pocetsvobod;

            }
            return soucet;
        }

        public int Spoctisvobodvretezu(int xx, int yy, Barva b)
        {
            int soucet = 0;
            List<Kamen> p = new List<Kamen>();
            Retezec(xx, yy, p, b);
            foreach (Kamen svobodyvretezu in p)
            {
                if (svobodyvretezu == null) continue;
                soucet = soucet + svobodyvretezu.Pocetsvobod;

            }
            return soucet;
        }

        public void Odstranretezec(int xx, int yy)
        {

            List<Kamen> p = new List<Kamen>();
            Retezec(xx, yy, p);
            foreach (Kamen kamen in p)
            {
                polekamenu[kamen.XX, kamen.YY] = null;
                Kamen[] zvysit = Sousedekamene(kamen.XX, kamen.YY);
                for (int i = 0; i < zvysit.Length; i++)
                {
                    zvysit[i].Zvysitpocetsvobod();

                }
                Console.WriteLine("Odstranuji kamen na pozici [{0},{1}]", kamen.XX, kamen.YY);
            }
        }

        public bool Zkontrolujtah(int xx, int yy, Barva b)
        {

            if ((polekamenu[xx, yy] == null) && ((Spoctisvobodvretezu(xx, yy, b) != 0) || Spoctisvobodkamene(xx, yy) != 0))
            {
                return true;
            }
            else
            {
                return false;

            }

        }
        public Kamen Kamennadesce(int x, int y)
        {
            return polekamenu[x, y];
        }
    }


    class Souradnice : BaseInteractiveShape
    {
        double xw;
        double yh;
        int xx;
        int yy;


        public Souradnice(Canvas canvas, double width, double height, int xx, int yy)
            : base(canvas)
        {
            this.yh = height;
            this.xw = width;
            this.xx = xx;
            this.yy = yy;
        }

        public override void Interaction(MouseButtons button, Position positionmouse)
        {
            Program.spravce.Polozkamen(xx, yy);
            Layer++;
            Layer--;
        }

        public override Position LeftTopCorner
        {
            get { return new Position(0, 0); }
        }

        public override Position RightBottomCorner
        {
            get { return new Position(xw, yh); }
        }


        public override void Painting()
        {
            Canvas.DrawFilledTriangle(this, new Position(0, 0), new Position(0, yh), new Position(xw, 0), new Color(255, 255, 0) + Color.White);
            Canvas.DrawFilledTriangle(this, new Position(xw, yh), new Position(0, yh), new Position(xw, 0), new Color(255, 255, 0) + Color.White);
            Canvas.DrawLine(this, new Position(0, yh / 2), new Position(xw, yh / 2), 2, Color.LightGray); //vodorovna cara x
            Canvas.DrawLine(this, new Position(xw / 2, 0), new Position(xw / 2, yh), 2, Color.LightGray); //svisla cara y
            if (Program.spravce.Kamennadesce(xx, yy) != null)
            {
                // http://lubovo.misto.cz/_MAIL_/curves/bezierr.html
                Canvas.DrawBezierCurve(this, new Position(0, yh / 2), new Position(0, 0), new Position(xw, 0), new Position(xw, yh / 2), 3, (Program.spravce.Kamennadesce(xx, yy).Jakabarva == Barva.cerna) ? Color.Black : Color.White);
                Canvas.DrawBezierCurve(this, new Position(0, yh / 2), new Position(0, yh), new Position(xw, yh), new Position(xw, yh / 2), 3, (Program.spravce.Kamennadesce(xx, yy).Jakabarva == Barva.cerna) ? Color.Black : Color.White);
            }
        }
    }



    class Hrac
    {
        string jmeno;
        Barva barva;

        public Hrac(string jmeno, Barva barva)
        {
            this.jmeno = jmeno;
            this.barva = barva;
        }

        public Barva Barvahrace
        {
            get { return barva; }
        }

        public string Jmeno
        {
            get { return jmeno; }
        }

    }

    class SpravceHry
    {
        KamenNaCanvas deska;
        Hrac prvni;
        Hrac druhy;
        Hrac aktualni;

        public SpravceHry(int rozmer, string jmeno1, string jmeno2)
        {
            this.deska = new KamenNaCanvas(rozmer);
            this.prvni = new Hrac(jmeno1, Barva.cerna);
            this.druhy = new Hrac(jmeno2, Barva.bila);
            this.aktualni = prvni;

        }

        public bool Polozkamen(int xx, int yy)
        {

            if (deska.PolozKamen(aktualni.Barvahrace, xx, yy)) //pokud se povede polozit kamen
            {
                aktualni = (aktualni == prvni) ? druhy : prvni;

                return true;
            }
            return false;


        }
        public Hrac Aktualnihrac
        {
            get { return aktualni; }
        }

        public Kamen Kamennadesce(int x, int y)
        {
            return deska.Kamennadesce(x, y);
        }

    }


    class Program
    {
        public static SpravceHry spravce;
        public static int rozmer;
        public static string jmeno1;
        public static string jmeno2;
        static void Main(string[] args)
        {
            Menu.HlavniMenu();
            spravce = new SpravceHry(rozmer, jmeno1, jmeno2);


            Canvas canvas = (new CanvasFactory(600, 600)).BestCanvas;

            for (int xx = 0; xx < rozmer; xx++)
            {
                for (int yy = 0; yy < rozmer; yy++)
                {
                    Souradnice k = new Souradnice(canvas, (canvas.Width) / rozmer, canvas.Height / rozmer, xx, yy);  //xx, yy - urcuje souradnice v negraficke herni plose
                    //s jakou velikosti bude vykreslovat krizek v pomeru s plochou
                    k.Location = new Position(((canvas.Width - 20) / (double)rozmer) * yy, ((canvas.Height - 40) / (double)rozmer) * xx); //umistovani krizku
                    // nastaveni optimalni velikosti canvasu
                }
            }


            Zmenatextu t = new Zmenatextu(canvas, "Na tahu je hrac: ");
            t.Layer = 2;
            canvas.Display();
        }
    }
    class Zmenatextu : Text
    {
        public Zmenatextu(Canvas canvas, string textnatahu) : base(canvas, textnatahu) { }

        public override void Painting()
        {
            Canvas.DrawText(this, Position.Origin, CurrentText + Program.spravce.Aktualnihrac.Jmeno, Font.Monospace, Color.Black);
        }
    }
}